#ifndef _LSUP_BUFFER_H
#define _LSUP_BUFFER_H

#include "core.h"

typedef struct LSUP_Buffer {
    void *addr;
    size_t size;
} LSUP_Buffer;


LSUP_Buffer *LSUP_buffer_new(size_t size);

int LSUP_buffer_init(LSUP_Buffer *buf, size_t size);

void LSUP_buffer_print(const LSUP_Buffer *buf);

void LSUP_buffer_done(LSUP_Buffer *buf);

inline bool LSUP_buffer_eq(
        const LSUP_Buffer *buf1, const LSUP_Buffer *buf2)
{
    if (buf1->size != buf2->size) return false;

    return (memcmp(buf1->addr, buf2->addr, buf1->size) == 0) ? true : false;
}

#endif
